// File Name: ServerImpl.java
// Date: Feb 19, 2003
// Edited by: Eiji Inoue

import java.rmi.*;
import java.rmi.server.*;

public class ServerImpl extends UnicastRemoteObject implements Server {
	Client client;
	static String serverName;
        static int[] r_cmd, r_dat;
	static camac p;


	static {
		try {
			serverName = java.net.InetAddress.getLocalHost().getHostName();
		}catch(Exception e){
			serverName = "localhost";
		} 
	}
	
	public ServerImpl() throws Exception {
		super();
	        r_cmd = new int[4096*16];
	        r_dat = new int[4096*16];
		p = new camac();

	} 
	
	public void register (Client aclient) {
		client = aclient;
	}
	
	public void camac_cmd(int[] cmd, int[] dat, int length) throws RemoteException{

           System.out.println(" RMI: Server side: ");
           System.out.println("   RMI: Received CAMAC command: " + "array length = " + length);
           for (int i = 0; i < length + 1; i++)
               System.out.println("      cmd[" + i + "] = 0x" + Integer.toHexString(cmd[i]) + ", dat[" + i + "] = 0x" + Integer.toHexString(dat[i]));

	ServerImpl.r_cmd = cmd;
	ServerImpl.r_dat = dat;

//JNI
    try{
    System.out.println();
    System.out.println("   JNI, Java side: before Native Call");
    for (int i = 0; i < length + 1; i++)
         System.out.println("      ServerImpl.r_cmd[" + i + "] = 0x" + Integer.toHexString(ServerImpl.r_cmd[i]) + ", ServerImpl.r_dat[" + i + "] = 0x" + Integer.toHexString(ServerImpl.r_dat[i]));


    int sum = ServerImpl.p.cmdArray(ServerImpl.r_cmd, ServerImpl.r_dat, length);

    System.out.println();
    System.out.println("   JNI, Java side: after Native Call" + " array length = " + length);
    for (int i = 0; i < length + 1; i++)
         System.out.println("      ServerImpl.r_cmd[" + i + "] = 0x" + Integer.toHexString(ServerImpl.r_cmd[i]) + ", ServerImpl.r_dat[" + i + "] = 0x" + Integer.toHexString(ServerImpl.r_dat[i]));

        client.camac_reply (ServerImpl.r_cmd, ServerImpl.r_dat, length);

   } catch ( Exception e ) {
       System.err.println ("Failed to exec for camac");
   }

//JNI end
	}
	
	public static void main(String argv[]) throws Exception {
		//System.setSecurityManager(new RMISecurityManager());
		ServerImpl obj = new ServerImpl();
		Naming.bind("//"+serverName+"/Server", obj);
		System.out.println("bind done");
	}  
}
